; 
    include \masm32\include\masm32rt.inc
; 
    LINELEN equ 100
    NLINES  equ 100000

    append_disk_file PROTO :DWORD,:DWORD,:DWORD
    
    .data
      hMem      dd 0
      linebuff  db LINELEN dup(0)
      nbuff     db 8 dup(0),0
    .code
; 
start:
; 
    mov   hMem,alloc(NLINES*LINELEN)

    xor   ebx, ebx
    .WHILE ebx < NLINES
      xor   edi, edi

      invoke dw2hex, ebx, ADDR nbuff
      invoke MemCopy, ADDR nbuff, ADDR linebuff, 8
      add   edi, 8      

      mov   [linebuff+edi], ' '
      add   edi, 1

      .WHILE edi < LINELEN-2
        invoke nrandom, 96
        add   eax, 32
        mov   [linebuff+edi],al
        add   edi, 1
      .ENDW
      mov   [linebuff+edi],13
      mov   [linebuff+edi+1],10

      mov   eax, LINELEN
      mul   ebx
      add   eax, hMem
      invoke MemCopy, ADDR linebuff, eax, LINELEN
      add   ebx, 1

    .ENDW

    invoke append_disk_file, chr$("bigfile.asm"),
                             hMem,
                             NLINES*LINELEN
    free hMem

    inkey "Press any key to exit..."
    exit

; 
; This is the MASM32 write_disk_file procedure modified to
; append the data to the specified file.
; 

append_disk_file proc lpName:DWORD,lpData:DWORD,nbytes:DWORD

comment * -------------------------------------------
        return value is the number of bytes written
        if the procedure succeeds or zero if it fails
        ------------------------------------------- *

    LOCAL hOutput:DWORD
    LOCAL bw     :DWORD

    invoke CreateFile,lpName,GENERIC_WRITE,NULL,NULL,
                      OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL

    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    xor eax, eax
    ret
  @@:
    mov hOutput, eax
    invoke SetFilePointer,hOutput,NULL,NULL,FILE_END
    invoke WriteFile,hOutput,lpData,nbytes,ADDR bw,NULL
    invoke FlushFileBuffers,hOutput
    invoke CloseHandle,hOutput

    mov eax, bw                 ; return written byte count
    ret

append_disk_file endp

; 

end start
 